<template>
  <div
    class="header"
    :class="computeClasses('header')"
  >
    <div class="header__container">
      <div
        v-if="isDesktop"
        class="header__menu"
      >
        <slot name="menu" />
      </div>
      <div class="header__logo">
        <slot name="logo" />
      </div>
      <div
        v-if="isDesktop"
        class="header__side"
      >
        <slot name="side" />
      </div>
      <div
        v-if="!isDesktop"
        class="header__menu-trigger"
      >
        <Button
          size="sm"
          @click="toggleMenu"
        >
          <Icon
            type="hamburger"
            size="sm"
          />
        </Button>
      </div>
      <div
        v-if="!isDesktop && isMenuActive"
        class="header__popup"
      >
        <div class="header__popup-menu">
          <slot name="menu" />
        </div>
        <div class="header__popup-side">
          <slot name="side" />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import bpMixin from '../../mixins/bpMixin';
import Icon from '../icon/Icon';
import Button from '../button/Button';

export default {
  name: 'Header',
  components: { Button, Icon },
  mixins: [bpMixin],
  data() {
    return {
      isMenuActive: false,
    };
  },
  watch: {
    isDesktop() {
      this.isMenuActive = false;
    },
  },
  methods: {
    toggleMenu() {
      this.isMenuActive = !this.isMenuActive;
    },
  },
};
</script>

<style lang="scss">
  @import "./header";
</style>
